#include <cuda.h>
#include "cudaTimer.h"

extern "C"
void createTimer(cudaTimer_t* timer) {
        #pragma omp critical (create_timer)
        {
                cudaEventCreate(&(timer->start));
                cudaEventCreate(&(timer->stop));
                timer->et = (float*) malloc(sizeof(float));
                *(timer->et) = 0.0f;
        }
}

extern "C"
void deleteTimer(cudaTimer_t timer) {
        #pragma omp critical (delete_timer)
        {
                cudaEventDestroy(timer.start);
                cudaEventDestroy(timer.stop);
                free(timer.et);
        }
}

extern "C"
void resetTimer(cudaTimer_t* timer) {
        #pragma omp critical (create_timer)
        {
                *(timer->et) = 0.0f;
        }
}

extern "C"
void startTimer(cudaTimer_t timer) {
        cudaEventRecord(timer.start,0);
}

extern "C"
void stopTimer(cudaTimer_t timer) {
        cudaEventRecord(timer.stop,0);
        cudaEventSynchronize(timer.stop);
        float tmp;
        cudaEventElapsedTime(&tmp,timer.start,timer.stop);
        *(timer.et) += tmp;
}

extern "C"
float getTimerValue(cudaTimer_t timer) {
        return *(timer.et);
}

