#ifndef _COPY_BOUNDARY_RAS_WQF_EO_H
#define _COPY_BOUNDARY_RAS_WQF_EO_H

extern "C" void copy_boundary_ras_wqf_eo(mic_ras_wqf_eo *qe);

const int mybz = 128;
static char *
norasval(const mic_wqf_eo *qe, int iz, int iy, int ix, char *buf)
{
    int isite = get_site(0, iz, iy, ix);
    snprintf(buf, mybz, "%12g", ((float *)&qe->s[isite].y[0])[0]);
    return buf;
}
static char *
rasval(const mic_ras_wqf_eo *qe, int iz, int iy, int ix, char *buf)
{
    int isite_ras = get_ras_site(0, iz, iy, ix);
    snprintf(buf, mybz, "%12g", ((float *)&qe->s[isite_ras].y[0])[0]);
    return buf;
}

static void
prcorners_ras(char *tag, const mic_ras_wqf_eo *qe)
{
    char buf[mybz];
    printf("%s: X planes\n", tag);
    printf("(   2,   2,   1) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+2-1,NDEPTHX+1-1,buf));
    printf("(NZ-1,   2,   1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+2-1,NDEPTHX+1-1,buf));
    printf("(   2,NY-1,   1) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+NY-1-1,NDEPTHX+1-1,buf));
    printf("(NZ-1,NY-1,   1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+NY-1-1,NDEPTHX+1-1,buf));
    printf("(   2,   2,  NX) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+2-1,NDEPTHX+NX-1,buf));
    printf("(NZ-1,   2,  NX) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+2-1,NDEPTHX+NX-1,buf));
    printf("(   2,NY-1,  NX) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+NY-1-1,NDEPTHX+NX-1,buf));
    printf("(NZ-1,NY-1,  NX) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+NY-1-1,NDEPTHX+NX-1,buf));
    printf("%s: Y planes\n", tag);
    printf("(   2,   1,   2) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+1-1,NDEPTHX+2-1,buf));
    printf("(NZ-1,   1,   2) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+1-1,NDEPTHX+2-1,buf));
    printf("(   2,  NY,   2) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+NY-1,NDEPTHX+2-1,buf));
    printf("(NZ-1,  NY,   2) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+NY-1,NDEPTHX+2-1,buf));
    printf("(   2,   1,NX-1) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+1-1,NDEPTHX+NX-1-1,buf));
    printf("(NZ-1,   1,NX-1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+1-1,NDEPTHX+NX-1-1,buf));
    printf("(   2,  NY,NX-1) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+NY-1,NDEPTHX+NX-1-1,buf));
    printf("(NZ-1,  NY,NX-1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+NY-1,NDEPTHX+NX-1-1,buf));
    printf("%s: Z planes\n", tag);
    printf("(   1,   2,   2) %s\n",
      rasval(qe,NDEPTHZ+1-1,NDEPTHY+2-1,NDEPTHX+2-1,buf));
    printf("(  NZ,   2,   2) %s\n",
      rasval(qe,NDEPTHZ+NZ-1,NDEPTHY+2-1,NDEPTHX+2-1,buf));
    printf("(   1,NY-1,   2) %s\n",
      rasval(qe,NDEPTHZ+1-1,NDEPTHY+NY-1-1,NDEPTHX+2-1,buf));
    printf("(  NZ,NY-1,   2) %s\n",
      rasval(qe,NDEPTHZ+NZ-1,NDEPTHY+NY-1-1,NDEPTHX+2-1,buf));
    printf("(   1,   2,NX-1) %s\n",
      rasval(qe,NDEPTHZ+1-1,NDEPTHY+2-1,NDEPTHX+NX-1-1,buf));
    printf("(  NZ,   2,NX-1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1,NDEPTHY+2-1,NDEPTHX+NX-1-1,buf));
    printf("(   1,NY-1,NX-1) %s\n",
      rasval(qe,NDEPTHZ+1-1,NDEPTHY+NY-1-1,NDEPTHX+NX-1-1,buf));
    printf("(  NZ,NY-1,NX-1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1,NDEPTHY+NY-1-1,NDEPTHX+NX-1-1,buf));
}

static void
prcorners(char *tag, const mic_wqf_eo *qe)
{
    char buf[mybz];
    printf("%s: X planes\n", tag);
    printf("(   2,   2,   1) %s\n",
      norasval(qe,2-1,2-1,1-1,buf));
    printf("(NZ-1,   2,   1) %s\n",
      norasval(qe,NZ-1-1,2-1,1-1,buf));
    printf("(   2,NY-1,   1) %s\n",
      norasval(qe,2-1,NY-1-1,1-1,buf));
    printf("(NZ-1,NY-1,   1) %s\n",
      norasval(qe,NZ-1-1,NY-1-1,1-1,buf));
    printf("(   2,   2,  NX) %s\n",
      norasval(qe,2-1,2-1,NX-1,buf));
    printf("(NZ-1,   2,  NX) %s\n",
      norasval(qe,NZ-1-1,2-1,NX-1,buf));
    printf("(   2,NY-1,  NX) %s\n",
      norasval(qe,2-1,NY-1-1,NX-1,buf));
    printf("(NZ-1,NY-1,  NX) %s\n",
      norasval(qe,NZ-1-1,NY-1-1,NX-1,buf));
    printf("%s: Y planes\n", tag);
    printf("(   2,   1,   2) %s\n",
      norasval(qe,2-1,1-1,2-1,buf));
    printf("(NZ-1,   1,   2) %s\n",
      norasval(qe,NZ-1-1,1-1,2-1,buf));
    printf("(   2,  NY,   2) %s\n",
      norasval(qe,2-1,NY-1,2-1,buf));
    printf("(NZ-1,  NY,   2) %s\n",
      norasval(qe,NZ-1-1,NY-1,2-1,buf));
    printf("(   2,   1,NX-1) %s\n",
      norasval(qe,2-1,1-1,NX-1-1,buf));
    printf("(NZ-1,   1,NX-1) %s\n",
      norasval(qe,NZ-1-1,1-1,NX-1-1,buf));
    printf("(   2,  NY,NX-1) %s\n",
      norasval(qe,2-1,NY-1,NX-1-1,buf));
    printf("(NZ-1,  NY,NX-1) %s\n",
      norasval(qe,NZ-1-1,NY-1,NX-1-1,buf));
    printf("%s: Z planes\n", tag);
    printf("(   1,   2,   2) %s\n",
      norasval(qe,1-1,2-1,2-1,buf));
    printf("(  NZ,   2,   2) %s\n",
      norasval(qe,NZ-1,2-1,2-1,buf));
    printf("(   1,NY-1,   2) %s\n",
      norasval(qe,1-1,NY-1-1,2-1,buf));
    printf("(  NZ,NY-1,   2) %s\n",
      norasval(qe,NZ-1,NY-1-1,2-1,buf));
    printf("(   1,   2,NX-1) %s\n",
      norasval(qe,1-1,2-1,NX-1-1,buf));
    printf("(  NZ,   2,NX-1) %s\n",
      norasval(qe,NZ-1,2-1,NX-1-1,buf));
    printf("(   1,NY-1,NX-1) %s\n",
      norasval(qe,1-1,NY-1-1,NX-1-1,buf));
    printf("(  NZ,NY-1,NX-1) %s\n",
      norasval(qe,NZ-1,NY-1-1,NX-1-1,buf));
}

static void
prshadow(char *tag, const mic_ras_wqf_eo *qe)
{
    char buf[mybz];
#if _NDIMX != 1
    printf("%s: X shadow planes\n", tag);
    printf("(   2,   2,   0) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+2-1,NDEPTHX+0-1,buf));
    printf("(NZ-1,   2,   0) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+2-1,NDEPTHX+0-1,buf));
    printf("(   2,NY-1,   0) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+NY-1-1,NDEPTHX+0-1,buf));
    printf("(NZ-1,NY-1,   0) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+NY-1-1,NDEPTHX+0-1,buf));
    printf("(   2,   2,NX+1) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+2-1,NDEPTHX+NX+1-1,buf));
    printf("(NZ-1,   2,NX+1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+2-1,NDEPTHX+NX+1-1,buf));
    printf("(   2,NY-1,NX+1) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+NY-1-1,NDEPTHX+NX+1-1,buf));
    printf("(NZ-1,NY-1,NX+1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+NY-1-1,NDEPTHX+NX+1-1,buf));
#endif
#if _NDIMY != 1
    printf("%s: Y shadow planes\n", tag);
    printf("(   2,   0,   2) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+0-1,NDEPTHX+2-1,buf));
    printf("(NZ-1,   0,   2) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+0-1,NDEPTHX+2-1,buf));
    printf("(   2,NY+1,   2) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+NY+1-1,NDEPTHX+2-1,buf));
    printf("(NZ-1,NY+1,   2) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+NY+1-1,NDEPTHX+2-1,buf));
    printf("(   2,   0,NX-1) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+0-1,NDEPTHX+NX-1-1,buf));
    printf("(NZ-1,   0,NX-1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+0-1,NDEPTHX+NX-1-1,buf));
    printf("(   2,NY+1,NX-1) %s\n",
      rasval(qe,NDEPTHZ+2-1,NDEPTHY+NY+1-1,NDEPTHX+NX-1-1,buf));
    printf("(NZ-1,NY+1,NX-1) %s\n",
      rasval(qe,NDEPTHZ+NZ-1-1,NDEPTHY+NY+1-1,NDEPTHX+NX-1-1,buf));
#endif
#if _NDIMZ != 1
    printf("%s: Z shadow planes\n", tag);
    printf("(   0,   2,   2) %s\n",
      rasval(qe,NDEPTHZ+0-1,NDEPTHY+2-1,NDEPTHX+2-1,buf));
    printf("(NZ+1,   2,   2) %s\n",
      rasval(qe,NDEPTHZ+NZ+1-1,NDEPTHY+2-1,NDEPTHX+2-1,buf));
    printf("(   0,NY-1,   2) %s\n",
      rasval(qe,NDEPTHZ+0-1,NDEPTHY+NY-1-1,NDEPTHX+2-1,buf));
    printf("(NZ+1,NY-1,   2) %s\n",
      rasval(qe,NDEPTHZ+NZ+1-1,NDEPTHY+NY-1-1,NDEPTHX+2-1,buf));
    printf("(   0,   2,NX-1) %s\n",
      rasval(qe,NDEPTHZ+0-1,NDEPTHY+2-1,NDEPTHX+NX-1-1,buf));
    printf("(NZ+1,   2,NX-1) %s\n",
      rasval(qe,NDEPTHZ+NZ+1-1,NDEPTHY+2-1,NDEPTHX+NX-1-1,buf));
    printf("(   0,NY-1,NX-1) %s\n",
      rasval(qe,NDEPTHZ+0-1,NDEPTHY+NY-1-1,NDEPTHX+NX-1-1,buf));
    printf("(NZ+1,NY-1,NX-1) %s\n",
      rasval(qe,NDEPTHZ+NZ+1-1,NDEPTHY+NY-1-1,NDEPTHX+NX-1-1,buf));
#endif
}

#endif

