#ifndef _MIC_TIMER_H
#define _MIC_TIMER_H

extern "C"
typedef struct {
        double start;
        double stop;
        double et;
} micTimer_t;

extern "C" void      __createTimer(micTimer_t &timer);
extern "C" void      __deleteTimer(micTimer_t &timer);
extern "C" void       __resetTimer(micTimer_t &timer);
extern "C" void       __startTimer(micTimer_t &timer);
extern "C" void        __stopTimer(micTimer_t &timer);
extern "C" double  __getTimerValue(micTimer_t &timer);

#ifdef _TIMING_

#define    createTimer(_x)   __createTimer(_x)
#define    deleteTimer(_x)   __deleteTimer(_x)
#define     resetTimer(_x)    __resetTimer(_x)
#define     startTimer(_x)    __startTimer(_x)
#define      stopTimer(_x)     __stopTimer(_x)
#define  getTimerValue(_x) __getTimerValue(_x)

#else

#define    createTimer(_x)   {}
#define    deleteTimer(_x)   {}
#define     resetTimer(_x)   {}
#define     startTimer(_x)   {}
#define      stopTimer(_x)   {}
#define  getTimerValue(_x)   (0.0)

#endif

#endif
