////////////////////////////////////////////////////////////////////////////////////
// MIC native solver code used in the offload region.
// This native code will be called by the host program from the offload region.
// The inter-node-communication used in the native code are reversely 
// offloaded to the host program.
//
// Comple this with -mmic option.
////////////////////////////////////////////////////////////////////////////////////

#include "cconfig.h"
#include "cmic_config.h"

#include <omp.h>
#include <complex>
#include <immintrin.h>
#include <stdio.h>
#include <stdlib.h>

#include "mic_nodeinfo.h"

//////////////////////////////////////////////
// Reverse offload communcation interface
// SCIF is used.
//////////////////////////////////////////////
#include "scif_interface.h"
extern SCIF_Interface *scif_mic;

namespace native_mic_solver_class {

//////////////////////////////////////////
// Keep node infor in the native code
//////////////////////////////////////////
static int mic_nodeid;
static int mic_nodeid_x_up;
static int mic_nodeid_y_up;
static int mic_nodeid_z_up;
static int mic_nodeid_x_dn;
static int mic_nodeid_y_dn;
static int mic_nodeid_z_dn;
static int mic_nodeid_x;
static int mic_nodeid_y;
static int mic_nodeid_z;
static int mic_ipdeo;
static int mic_ipeo;

#include "micTimer.h"

#include "flop_table.h"

#include "mic_wrapper_func.h"

#include "mic_param_size.h"

#include "mic_solver_timer.h"
#include "mic_mpi.h"
//#include "mic_mpi2.h"

#include "mic_su3_basic_algebla.h"
//#include "avx_su3_basic_algebla.h"
#include "mic_wqf_algebra.h"

#include "assign_inv_matvec_mic.h"

#include "mic_ras_solver_class.h"

//#include "mic_sap_solver_class.h"


}
