module iso_c_functions
use iso_c_binding
implicit none
private
public :: f_mkdir

interface 
  subroutine pf_mkdir(path,ierr) BIND(C,name="c_mkdir")
  use iso_c_binding
  implicit none
  character(kind=C_CHAR,len=1), intent(in)    :: path(*)
  integer(C_INT),               intent(inout) :: ierr
  end subroutine
end interface

contains

subroutine f_mkdir(path,ierr)
  implicit none
  character(len=*), intent(in)    :: path
  integer,          intent(inout) :: ierr
  character(kind=C_CHAR,len=1), allocatable :: c_path(:)
  integer :: length,i

  !---------------------------------------------
  ! To convert C string,
  ! add a null terminator to the fortran string
  !---------------------------------------------
  length = LEN(TRIM(ADJUSTL(path)))+1
  allocate(c_path(length))
  do i=1,length-1
    c_path(i) = path(i:i)
  enddo
  c_path(length) = C_NULL_CHAR  

  call pf_mkdir(c_path,ierr)
  deallocate(c_path)
  return
end subroutine

end module
